---------------------------------------------------------------------------
--Main Module
---------------------------------------------------------------------------
--Loads all submodules....


dofile("quat.lua")
dofile("arcball.lua")
dofile("scene.lua")
dofile("animation.lua")
dofile("arena.lua")
dofile("probe.lua")
dofile("score.lua")
dofile("gui.lua")
dofile("simulator.lua")---*
dofile("userrobot.lua")-- *--Must Follow This order.
dofile("privrobot.lua")---*

-----------------------------------------------------------------------------
-- Init:
-----------------------------------------------------------------------------
GUI.dlgArena:map()
IupGLMakeCurrent(GUI.glcMain)
gl_clearcolor(0.2, 0.2, 0.6)
gl_shademodel(GL_SMOOTH)
gl_enable(GL_NORMALIZE)
gl_enable(GL_AUTO_NORMAL)

gl_light(GL_LIGHT0, GL_DIFFUSE, 0.2, 0.3, 0.4, 1)
gl_light(GL_LIGHT0, GL_SPECULAR, 1, 1, 1, 1)
gl_light(GL_LIGHT0, GL_AMBIENT, 0.2, 0.2, 0.2, 1)

gl_light(GL_LIGHT1, GL_DIFFUSE, 0.4, 0.4, 0.4, 1)
gl_light(GL_LIGHT1, GL_SPECULAR, 0.6, 0.6, 0.6, 1)
gl_light(GL_LIGHT1, GL_AMBIENT, 0.2, 0.2, 0.2, 1)

gl_enable(GL_LIGHTING)
gl_enable(GL_LIGHT0)
gl_enable(GL_LIGHT1)
gl_enable(GL_DEPTH_TEST)
--gl_enable(GL_FOG)
gl_fog(GL_FOG_MODE, GL_LINEAR)
gl_fog(GL_FOG_COLOR, 0.2, 0.2, 0.6, 1.0)
gl_fog(GL_FOG_DENSITY, 0.01)
gl_hint(GL_FOG_HINT, GL_DONT_CARE)
gl_fog(GL_FOG_START, 5)
gl_fog(GL_FOG_END, 8)

randomseed(gl_time())
Simulator.init()

IupSetLanguage(IUP_ENGLISH)
GUI.dlgArena:show()

--Test Mode
local arg = arg or {}
if arg[1] then 
    local ret, Terr, Aerr
    ret, Terr = Simulator.addTeam(arg[1], "255 0 0", 2, "samples/"..arg[1]..".lua")
    if not ret then IupMessage("Erro Acrescentado Time:", Terr) end
    ret, Terr = Simulator.addTeam(arg[2], "0 0 255", 2, "samples/"..arg[2]..".lua")
    if not arg[3] then arg[3]="arena1.arn" end
    ret, Aerr = Arena.load("arenas/"..arg[3]..".arn")
    if not ret then IupMessage("Erro Carregando Arena:", Aerr) end
    if not Terr then GUI.teamOK=1 end
    if not Aerr then GUI.arenaOK=1 end
    GUI.checkReady()
    GUI.itemSetup.active = IUP_NO
    print("Modo de campeonato comeando com "..arg[1].." e " ..arg[2].." na "..arg[3])
    GUI.itemRes.action() -- Set schematic mode
    GUI.itemStep.action()
    GUI.start()
else
    print("Modo normal comeando")
end
